Option Explicit On
Option Strict On


Public Class fwterm

    Private mIniFile As w2IniFile
    Private mPort As New IO.Ports.SerialPort
    Private mTxt As w2TxtBuffer
    Private Sub autobaud()

        btnConnect.Enabled = False
        Label24.Visible = True
        Label24.BackColor = Color.Green
        Dim j As Integer = 0
        While j < cboRate.Items.Count

            'close port
            If mPort IsNot Nothing Then mPort.Close()
            'set port properties
            cboRate.SelectedIndex = j
            mPort.PortName = cboPort.Text
            mPort.BaudRate = Convert.ToInt32(cboRate.Text)
            mPort.DataBits = Convert.ToInt32(cboData.Text)

            mPort.Parity = CType([Enum].Parse(GetType(IO.Ports.Parity), cboParity.Text), IO.Ports.Parity)
            mPort.StopBits = CType([Enum].Parse(GetType(IO.Ports.StopBits), cboStop.Text), IO.Ports.StopBits)

            'try connection
            Try
                mPort.Open()
            Catch ex As Exception
                MessageBox.Show(ex.Message, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Information)
                Return
            End Try

            'set 
            mPort.NewLine = ControlChars.Cr
            'mPort.ReadTimeout = 1000   'this is not needed as we are going to use DataReceived event
            AddHandler mPort.DataReceived, AddressOf DataReceived

            Question = 1
            Info.Text = ""
            mPort.WriteLine("AT" & vbCrLf)
            Dim i As Integer
            For i = 1 To 8
                System.Threading.Thread.Sleep(1000)
                System.Windows.Forms.Application.DoEvents()
            Next

            If Info.Text = "OK" Then
                j = cboRate.Items.Count + 1
            End If
            j = j + 1
            If Label24.BackColor = Color.Green Then
                Label24.BackColor = Color.Red
            Else
                Label24.BackColor = Color.Green
            End If

        End While
        'save info
        mIniFile.WriteParemeter("Port", "Port", cboPort.Text)
        mIniFile.WriteParemeter("Port", "BaudRate", cboRate.Text)
        mIniFile.WriteParemeter("Port", "DataBits", cboData.Text)
        mIniFile.WriteParemeter("Port", "StopBits", cboStop.Text)
        mIniFile.WriteParemeter("Port", "Parity", cboParity.Text)
        btnConnect.Enabled = True
        Label24.Visible = False

    End Sub


    Private Sub ConnectPort()
        'check port properties
        If cboPort.SelectedIndex = -1 Then Return
        If cboRate.SelectedIndex = -1 Then Return
        If cboParity.SelectedIndex = -1 Then Return
        If cboData.SelectedIndex = -1 Then Return
        If cboStop.SelectedIndex = -1 Then Return



        If CheckBox9.Checked = False Then
            'close port
            If mPort IsNot Nothing Then mPort.Close()
            'set port properties
            mPort.PortName = cboPort.Text
            mPort.BaudRate = Convert.ToInt32(cboRate.Text)
            mPort.DataBits = Convert.ToInt32(cboData.Text)

            mPort.Parity = CType([Enum].Parse(GetType(IO.Ports.Parity), cboParity.Text), IO.Ports.Parity)
            mPort.StopBits = CType([Enum].Parse(GetType(IO.Ports.StopBits), cboStop.Text), IO.Ports.StopBits)

            'try connection
            Try
                mPort.Open()
            Catch ex As Exception
                MessageBox.Show(ex.Message, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Information)
                Return
            End Try

            'set 
            mPort.NewLine = ControlChars.Cr
            'mPort.ReadTimeout = 1000   'this is not needed as we are going to use DataReceived event
            AddHandler mPort.DataReceived, AddressOf DataReceived

            'save info
            mIniFile.WriteParemeter("Port", "Port", cboPort.Text)
            mIniFile.WriteParemeter("Port", "BaudRate", cboRate.Text)
            mIniFile.WriteParemeter("Port", "DataBits", cboData.Text)
            mIniFile.WriteParemeter("Port", "StopBits", cboStop.Text)
            mIniFile.WriteParemeter("Port", "Parity", cboParity.Text)
        Else
            autobaud()
        End If
        
    End Sub

    ''' <summary>
    ''' Note that this is called from a backrbound thread
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub DataReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs)
        If e.EventType = IO.Ports.SerialData.Chars Then ShowReceived()
    End Sub

    ''' <summary>
    ''' The following handles the actual call from DataReceived in a thread safe way.
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub ShowReceived()
        Static s As String = ""
        'Dim idx As Integer = 0
        'Dim sData() As String

        If Me.InvokeRequired Then
            'invoke the thread
            Me.Invoke(New MethodInvoker(AddressOf ShowReceived))
        Else
            s += mPort.ReadExisting()
            If Question = 1 Then
                Info.Text = s
                Question = 0
            Else
                RichTextBox1.Text &= s
                RichTextBox1.SelectionStart = RichTextBox1.TextLength
                RichTextBox1.ScrollToCaret()

            End If
            s = ""
        End If

    End Sub

    Private Sub fwterm_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim i As Integer
        Dim s As String
        Dim x As Object()

        'ini file
        mIniFile = New w2IniFile(IO.Path.Combine(System.AppDomain.CurrentDomain.BaseDirectory(), "wterm.ini"))

        'set port properties
        cboPort.DropDownStyle = ComboBoxStyle.DropDownList
        For Each s In My.Computer.Ports.SerialPortNames
            cboPort.Items.Add(s)
        Next
        s = mIniFile.ReadParameter("Port", "Port", "")
        cboPort.SelectedIndex = cboPort.Items.IndexOf(s)

        cboRate.DropDownStyle = ComboBoxStyle.DropDownList
        x = New Object() {1200, 2400, 4800, 9600, 14400, 19200, 38400, 57600, 115200, 230400, 460800, 921600}
        cboRate.Items.AddRange(x)
        i = mIniFile.ReadParameter("Port", "BaudRate", 0)
        cboRate.SelectedIndex = cboRate.Items.IndexOf(i)

        cboParity.DropDownStyle = ComboBoxStyle.DropDownList
        For Each s In [Enum].GetNames(GetType(IO.Ports.Parity))
            cboParity.Items.Add(s)
        Next
        s = mIniFile.ReadParameter("Port", "Parity", "")
        cboParity.SelectedIndex = cboParity.Items.IndexOf(s)

        cboData.DropDownStyle = ComboBoxStyle.DropDownList
        x = New Object() {4, 5, 6, 7, 8}
        cboData.Items.AddRange(x)
        i = mIniFile.ReadParameter("Port", "DataBits", 0)
        cboData.SelectedIndex = cboData.Items.IndexOf(i)

        cboStop.DropDownStyle = ComboBoxStyle.DropDownList
        For Each s In [Enum].GetNames(GetType(IO.Ports.StopBits))
            cboStop.Items.Add(s)
        Next
        s = mIniFile.ReadParameter("Port", "StopBits", "")
        cboStop.SelectedIndex = cboStop.Items.IndexOf(s)

        'button 
        btnConnect.ImageList = ImageList
        btnConnect.Text = "Connexion"
        btnConnect.ImageKey = btnConnect.Text

        'terminal and enhancement
        lblPort.Text = ""
        PanelIO.Enabled = False

        mTxt = New w2TxtBuffer(txtSend)
        mTxt.ClearLastCommand = True
        chkCap.Checked = mIniFile.ReadParameter("Port", "CAPS", False)

        'me
        Me.Text = "Terminal- ESP8266"
        Me.MinimumSize = Me.Size()

        With ComboBox1.Items
            .Add("1200")
            .Add("2400")
            .Add("9600")
            .Add("14400")
            .Add("19200")
            .Add("38400")
            .Add("57600")
            .Add("115200")
            .Add("230400")
            .Add("460800")
            .Add("921600")
        End With


        With ComboBox2.Items
            .Add("?" & " Etat Actuel")
            .Add("=1" & " Client")
            .Add("=3" & " Mode Client & Point d'accs")
        End With

        With ComboBox6.Items
            .Add("?" & " Etat Actuel")
            .Add("=2" & " Point d'accs")
            .Add("=3" & " Mode Client & Point d'accs")
        End With

        ComboBox1.DropDownStyle = ComboBoxStyle.DropDownList
        ComboBox1.SelectedIndex = 0

        ComboBox2.DropDownStyle = ComboBoxStyle.DropDownList
        ComboBox2.SelectedIndex = 0

        ComboBox4.DropDownStyle = ComboBoxStyle.DropDownList
        ComboBox4.SelectedIndex = 0

        ComboBox5.DropDownStyle = ComboBoxStyle.DropDownList
        ComboBox5.SelectedIndex = 0

        ComboBox6.DropDownStyle = ComboBoxStyle.DropDownList
        ComboBox6.SelectedIndex = 0

        ComboBox7.SelectedIndex = 0
        ComboBox8.SelectedIndex = 0

 


    End Sub

    Private Sub btnConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConnect.Click
        If btnConnect.Text = "Connexion" Then
            ConnectPort()
        Else
            If mPort.IsOpen Then
                mPort.Close()
                RemoveHandler mPort.DataReceived, AddressOf DataReceived
            End If
        End If

        If mPort.IsOpen Then
            btnConnect.Text = "Dconnexion"
            PanelIO.Enabled = True
            lblPort.Text = "Connecter  " & cboPort.Text & ":" & cboRate.Text & ":" _
                            & cboParity.Text & ":" & cboData.Text & ":" & cboStop.Text
        Else
            btnConnect.Text = "Connexion"
            lblPort.Text = "Dconnexion"
            PanelIO.Enabled = False
        End If
        btnConnect.Image = ImageList.Images(btnConnect.Text)
    End Sub

    Private Sub chkCap_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkCap.CheckedChanged
        mTxt.Uppercase = chkCap.Checked
        mIniFile.WriteParemeter("Port", "CAPS", mTxt.Uppercase.ToString)
    End Sub

    Private Sub txtSend_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtSend.KeyPress
        If e.KeyChar = ControlChars.Cr Then
            If CheckBox7.Checked = True Then
                mPort.WriteLine(txtSend.Text & vbCrLf)
            Else
                mPort.WriteLine(txtSend.Text)
            End If

            txtSend.Text = ""
        End If
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        mPort.WriteLine("AT+RST" & vbCrLf)
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        mPort.WriteLine("AT+GMR" & vbCrLf)
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        mPort.WriteLine("AT+IPR=" & ComboBox1.Text & vbCrLf)
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        If CheckBox1.Checked Then
            mPort.WriteLine("ATE1" & vbCrLf)
            CheckBox1.Checked = False
        Else
            mPort.WriteLine("ATE0" & vbCrLf)
            CheckBox1.Checked = False
        End If
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click

        Dim envois As String = ComboBox2.Text
        Dim str() As String = ComboBox2.Text.Split(CChar(" "))
        envois = str(0)
        mPort.WriteLine("AT+CWMODE" & envois & vbCrLf)
    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        mPort.WriteLine("AT+CWLAP" & vbCrLf)
    End Sub

    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
        If TextBox1.Text = "?" Then
            mPort.WriteLine("AT+CWJAP?" & vbCrLf)
        Else
            mPort.WriteLine("AT+CWJAP=" & Chr(34) & TextBox1.Text & Chr(34) & "," & Chr(34) & TextBox2.Text & Chr(34) & vbCrLf)
            TextBox1.Text = "?"
        End If

    End Sub

    Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
        mPort.WriteLine("AT+CWQAP" & vbCrLf)
    End Sub

    Private Sub Button9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button9.Click
        mPort.WriteLine("AT" & vbCrLf)
    End Sub

    Private Sub Button16_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button16.Click
        Dim envois As String = ComboBox6.Text
        Dim str() As String = ComboBox6.Text.Split(CChar(" "))
        envois = str(0)
        mPort.WriteLine("AT+CWMODE" & envois & vbCrLf)
    End Sub

    Private Sub Button14_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button14.Click
        Dim envois As String = ComboBox5.Text
        Dim str() As String = ComboBox5.Text.Split(CChar(" "))
        envois = str(0)
        If TextBox6.Text = "?" Then
            mPort.WriteLine("AT+CWSAP?" & vbCrLf)
        Else
            mPort.WriteLine("AT+CWSAP=" & Chr(34) & TextBox6.Text & Chr(34) & "," & Chr(34) & TextBox5.Text & Chr(34) & "," & ComboBox4.Text & "," & envois & vbCrLf)
            TextBox6.Text = "?"
        End If
    End Sub

    Private Sub Button15_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button15.Click
        mPort.WriteLine("AT+CWLIF" & vbCrLf)
    End Sub


    Private Sub Button17_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button17.Click
        mode()
        Dim i As Integer
        For i = 1 To 2
            System.Threading.Thread.Sleep(1000)
            System.Windows.Forms.Application.DoEvents()
        Next
        If Info.Text = "Mode 1" Then
            If CheckBox2.Checked Then mPort.WriteLine("AT+CWDHCP=1,1" & vbCrLf) Else mPort.WriteLine("AT+CWDHCP=1,0" & vbCrLf)
        End If
        If Info.Text = "Mode 3" Then
            If CheckBox2.Checked Then mPort.WriteLine("AT+CWDHCP=2,1" & vbCrLf) Else mPort.WriteLine("AT+CWDHCP=2,0" & vbCrLf)
        End If

    End Sub

    Private Sub Button18_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Info.Text = ""
    End Sub


    Private Sub Info_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Info.TextChanged
        If (Info.Text.IndexOf("+CWMODE:1") <> -1) Then
            Info.Text = "Mode 1"
        End If
        If (Info.Text.IndexOf("+CWMODE:2") <> -1) Then
            Info.Text = "Mode 2"
        End If
        If (Info.Text.IndexOf("+CWMODE:3") <> -1) Then
            Info.Text = "Mode 3"
        End If
        If (Info.Text.IndexOf("OK") <> -1) Then
            Info.Text = "OK"
        End If
    End Sub
    Private Sub mode()
        Question = 1
        Info.Text = ""
        mPort.WriteLine("AT+CWMODE" & "?" & vbCrLf)
    End Sub

    Private Sub Button18_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button18.Click
        RichTextBox1.Text = ""
        RichTextBox1.ScrollBars = RichTextBoxScrollBars.None
        'RichTextBox1.ScrollToCaret()
        RichTextBox1.ScrollBars = RichTextBoxScrollBars.Both
    End Sub

    Private Sub Button19_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button19.Click
        mode()
        Dim i As Integer
        For i = 1 To 2
            System.Threading.Thread.Sleep(1000)
            System.Windows.Forms.Application.DoEvents()
        Next
        If Info.Text = "Mode 2" Then
            If CheckBox3.Checked Then mPort.WriteLine("AT+CWDHCP=0,1" & vbCrLf) Else mPort.WriteLine("AT+CWDHCP=0,0" & vbCrLf)
        End If
        If Info.Text = "Mode 3" Then
            If CheckBox3.Checked Then mPort.WriteLine("AT+CWDHCP=2,1" & vbCrLf) Else mPort.WriteLine("AT+CWDHCP=2,0" & vbCrLf)
        End If
    End Sub

    Private Sub Button20_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button20.Click
        If TextBox7.Text = "?" Then
            mPort.WriteLine("AT+CIPSTAMAC?" & vbCrLf)
        Else
            mPort.WriteLine("AT+CIPSTAMAC=" & Chr(34) & TextBox7.Text & Chr(34) & vbCrLf)
            TextBox7.Text = "?"
        End If
    End Sub

    Private Sub Button21_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button21.Click
        If TextBox8.Text = "?" Then
            mPort.WriteLine("AT+CIPAPMAC?" & vbCrLf)
        Else
            mPort.WriteLine("AT+CIPAPMAC=" & Chr(34) & TextBox8.Text & Chr(34) & vbCrLf)
            TextBox8.Text = "?"
        End If
    End Sub

    Private Sub Button22_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button22.Click
        If TextBox9.Text = "?" Then
            mPort.WriteLine("AT+CIPSTA?" & vbCrLf)
        Else
            mPort.WriteLine("AT+CIPSTA=" & Chr(34) & TextBox9.Text & Chr(34) & vbCrLf)
            TextBox9.Text = "?"
        End If
    End Sub

    Private Sub Button23_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button23.Click
        If TextBox10.Text = "?" Then
            mPort.WriteLine("AT+CIPAP?" & vbCrLf)
        Else
            mPort.WriteLine("AT+CIPAP=" & Chr(34) & TextBox10.Text & Chr(34) & vbCrLf)
            TextBox10.Text = "?"
        End If
    End Sub

    Private Sub LinkLabel1_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles LinkLabel1.LinkClicked
        System.Diagnostics.Process.Start(LinkLabel1.Text)
    End Sub

    Private Sub Button24_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button24.Click
        mPort.WriteLine("AT+CIPSTATUS" & vbCrLf)
    End Sub

    Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged

    End Sub

    Private Sub CheckBox4_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox4.CheckedChanged
        If CheckBox4.Checked = True Then
            Label19.Visible = True
            TextBox13.Visible = True
        Else
            Label19.Visible = False
            TextBox13.Visible = False
        End If
    End Sub

    Private Sub Button25_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button25.Click
        If CheckBox4.Checked = True Then
            mPort.WriteLine("AT+CIPSTART=" & TextBox13.Text & "," & Chr(34) & ComboBox7.Text & Chr(34) & "," & Chr(34) & TextBox11.Text & Chr(34) & "," & TextBox12.Text & vbCrLf)
        Else
            mPort.WriteLine("AT+CIPSTART=" & Chr(34) & ComboBox7.Text & Chr(34) & "," & Chr(34) & TextBox11.Text & Chr(34) & "," & TextBox12.Text & vbCrLf)
        End If

    End Sub

    Private Sub CheckBox5_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox5.CheckedChanged
        If CheckBox5.Checked = True Then
            Label20.Visible = True
            TextBox15.Visible = True
        Else
            Label20.Visible = False
            TextBox15.Visible = False
        End If
    End Sub

    Private Sub Button26_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button26.Click
        Dim longueur As Integer
        longueur = TextBox14.TextLength
        If CheckBox5.Checked = True Then
            mPort.WriteLine("AT+CIPSEND=" & TextBox15.Text & "," & longueur & vbCrLf)
            mPort.WriteLine(TextBox14.Text & vbCrLf)
        Else
            mPort.WriteLine("AT+CIPSEND=" & longueur & vbCrLf)
            mPort.WriteLine(TextBox14.Text & vbCrLf)
        End If

    End Sub

    Private Sub Button27_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button27.Click
        If CheckBox6.Checked = True Then
            mPort.WriteLine("AT+CIPCLOSE=" & TextBox16.Text & vbCrLf)

        Else
            mPort.WriteLine("AT+CIPCLOSE" & vbCrLf)
        End If
    End Sub

    Private Sub CheckBox6_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox6.CheckedChanged
        If CheckBox6.Checked = True Then
            Label22.Visible = True
            TextBox16.Visible = True
        Else
            Label22.Visible = False
            TextBox16.Visible = False
        End If
    End Sub

    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.

    End Sub


    Private Sub Button28_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button28.Click
        If CheckBox7.Checked = True Then
            mPort.WriteLine(txtSend.Text & vbCrLf)
        Else
            mPort.WriteLine(txtSend.Text)
        End If

        txtSend.Text = ""
    End Sub

    Private Sub Button29_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button29.Click
        mPort.WriteLine("AT+CIFSR" & vbCrLf)
    End Sub

    Private Sub Button30_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button30.Click
        If CheckBox8.Checked = True Then
            mPort.WriteLine("AT+CIPMUX=1" & vbCrLf)

        Else
            mPort.WriteLine("AT+CIPMUX=0" & vbCrLf)
        End If
    End Sub

    Private Sub Button32_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button32.Click
        mPort.WriteLine("AT+CIPSERVER=0" & vbCrLf)
    End Sub

    Private Sub Button31_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button31.Click
        mPort.WriteLine("AT+CIPMUX=1" & vbCrLf)
        System.Threading.Thread.Sleep(1000)
        mPort.WriteLine("AT+CIPSERVER=1" & "," & TextBox18.Text & vbCrLf)
    End Sub

    Private Sub Button33_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button33.Click
        If (ComboBox8.Text.IndexOf("0") <> -1) Then
            mPort.WriteLine("AT+CIPMODE=0" & vbCrLf)
        Else
            mPort.WriteLine("AT+CIPMODE=1" & vbCrLf)
            mPort.WriteLine("AT+CIPSEND" & vbCrLf)
        End If
    End Sub

    Private Sub Button34_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button34.Click
        If TextBox17.Text = "?" Then
            mPort.WriteLine("AT+CIPSTO?" & vbCrLf)
        Else
            mPort.WriteLine("AT+CIPSTO=" & TextBox17.Text & vbCrLf)
            TextBox17.Text = "?"
        End If
    End Sub


    Private Sub CheckBox9_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox9.CheckedChanged
        If CheckBox9.Checked Then
            cboRate.Enabled = False
        Else
            cboRate.Enabled = True
        End If
    End Sub


End Class
